/* 
Gramatica 10: 'gr10.pl'
*/

use_module(library(lists)).
ana_sem(A,D):-
	ej(A,B),
	a_lexic(B,C),
	a_sem(C,D),
	gestion_orden(D).

a_sem(A,B):-
	oracion(B,A,[]).

gestion_orden([declarativa,R]):-
	declarar(R).
gestion_orden([interrogativa,Que,Restricc]):-
	responder(Que,Restricc).
gestion_orden(_):-
	print('sin efectos'),nl.

responder(Que,Restricc):-
	ejecutar_restricciones(Restricc),
	print('la respuesta es '),
	print(Que),nl.
responder(_,_):-
	print('no lo se').

ejecutar_restricciones([]).
ejecutar_restricciones([Restr|Restrs]):-
	ejecutar_restriccion(Restr),
	ejecutar_restricciones(Restrs).
ejecutar_restriccion(R):-
	clause(R,_),
	R.

declarar([]).
declarar([Dec|Decs]):-
	declarar_1(Dec),
	declarar(Decs).
declarar_1(Dec):-
	modificar(Dec).

modificar(Dec):-
	retract(Dec),
	fail.
modificar(Dec):-
	assertz(Dec).

oracion(X) --> interrogativa(X).
oracion(X) --> declarativa(X).
declarativa([declarativa,L]) --> sn(Val,L), v_ser(_), sn_bas(Val).
interrogativa([interrogativa,X,L]) --> p_int(_), v_ser(_), sn(X,L), sig_int(_).
sn(X,[]) --> sn_bas(X).
sn(U,[R|Z]) --> sn_bas(X), sn_mod(Y,Z), {R =.. [X,Y,U]}.
sn_bas(X) --> np(X:_).
sn_bas(X) --> num(X:_).
sn_bas(X) --> det(_), n(X:_).
sn_mod(X,Y) --> sp(X,Y).
sp(X,Y)--> prep(_), sn(X,Y).

p_int(W) --> [W],{es_p_int(W)}.
v_ser(W) -->[W],{es_v_ser(W)}.
det(W) --> [W],{es_det(W)}.
n(W) --> [W],{es_n(W)}.
prep(W) --> [W],{es_prep(W)}.
np(W) -->[W],{es_np(W)}.
sig_int(W) --> [W],{es_sig_int(W)}.
num(W) --> [W],{es_num(W)}.

es_p_int(_:X):-
	member(p_int,X).
es_v_ser(_:X):-
	member(v_ser,X).
es_det(_:X):-
	member(det,X).
es_n(_:X):-
	member(n,X).
es_prep(_:X):-
	member(prep,X).
es_np(_:X):-
	member(np,X).
es_sig_int(_:X):-
	member(sig_int,X).
es_num(_:X):-
	member(num,X).

