
use_module(library(lists)).
ana_sem(A,D):-
	ej(A,B),
	a_lexic(B,C),
	a_sem(C,D).
a_sem(A,B):-
	oracion(B,A,[]).

oracion(X) --> interrogativa(X).
oracion(X) --> declarativa(X).
declarativa([declarativa,L]) --> sn(Val,L), v-ser(_), sn_bas(Val).
interrogativa([interrogativa,X,L]) --> p-int(_), v-ser(_), sn(X,L), sig-int(_).
sn(X,[]) --> sn_bas(X).
sn(U,[R|Z]) --> sn_bas(X), sn_mod(Y,Z), {R =.. [X,Y,U]}.
sn_bas(X) --> np(X:_).
sn_bas(X) --> det(_), n(X:_).
sn_mod(X,Y) --> sp(X,Y).
sp(X,Y)--> prep(_), sn(X,Y).

p-int(W) --> [W],{es-p-int(W)}.
v-ser(W) -->[W],{es-v-ser(W)}.
det(W) --> [W],{es-det(W)}.
n(W) --> [W],{es-n(W)}.
prep(W) --> [W],{es-prep(W)}.
np(W) -->[W],{es-np(W)}.
sig-int(W) --> [W],{es-sig-int(W)}.

es-p-int(_:X):-
	member(p-int,X).
es-v-ser(_:X):-
	member(v-ser,X).
es-det(_:X):-
	member(det,X).
es-n(_:X):-
	member(n,X).
es-prep(_:X):-
	member(prep,X).
es-np(_:X):-
	member(np,X).
es-sig-int(_:X):-
	member(sig-int,X).



